/***************************************************************************
 *   Copyright (C) 2003 by Roberto Raggi                                   *
 *   roberto@kdevelop.org                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KDEVTQTIMPORTER_H
#define KDEVTQTIMPORTER_H

#include <kdevpcsimporter.h>
#include <tqguardedptr.h>

class SettingsDialog;
class KTempFile;

class KDevQt4Importer : public KDevPCSImporter
{
    Q_OBJECT
  
public:
    KDevQt4Importer( TQObject* parent=0, const char* name=0, const TQStringList& args=TQStringList() );
    virtual ~KDevQt4Importer();

    virtual TQString dbName() const { return TQString::fromLatin1("TQt4"); }
    virtual TQStringList fileList();
    virtual TQStringList includePaths();

    virtual TQWidget* createSettingsPage( TQWidget* parent, const char* name=0 );

private:
    TQGuardedPtr<SettingsDialog> m_settings;
    KTempFile *m_qtfile;
};

#endif
